/**
*****************************************************************************
* File: ALFAT_SPI.h												   
* Copyright 2012 GHI Electronics, LLC 								   
* These are basic configurations to to access ALFAT SoC Processor through SPI interface.
* For demonstration purposes only. not to be used in production.
*
* THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
* ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
* CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.								   *
************************************************************************
**/
#include "..\\Driver\\stm32f2xx_spi.h"
#include "..\\Driver\\stm32f2xx_rcc.h"
#include "..\\Driver\\misc.h"
#include "..\\GPIO\\GPIO.h"




#define SPIx                           SPI1
#define SPIx_CLK                       RCC_APB2Periph_SPI1
#define SPIx_CLK_INIT                  RCC_APB2PeriphClockCmd
#define SPIx_IRQn                      SPI1_IRQn
#define SPIx_IRQHANDLER                SPI1_IRQHandler

#define SPIx_NSS_PIN                   GPIO_Pin_15
#define SPIx_NSS_GPIO_PORT             GPIOA
#define SPIx_NSS_GPIO_CLK              RCC_AHB1Periph_GPIOA
#define SPIx_NSS_SOURCE                GPIO_PinSource15
#define SPIx_NSS_AF                    GPIO_AF_SPI1


#define SPIx_SCK_PIN                   GPIO_Pin_3
#define SPIx_SCK_GPIO_PORT             GPIOB
#define SPIx_SCK_GPIO_CLK              RCC_AHB1Periph_GPIOB
#define SPIx_SCK_SOURCE                GPIO_PinSource3
#define SPIx_SCK_AF                    GPIO_AF_SPI1

#define SPIx_MISO_PIN                  GPIO_Pin_6
#define SPIx_MISO_GPIO_PORT            GPIOA
#define SPIx_MISO_GPIO_CLK             RCC_AHB1Periph_GPIOA
#define SPIx_MISO_SOURCE               GPIO_PinSource6
#define SPIx_MISO_AF                   GPIO_AF_SPI1

#define SPIx_MOSI_PIN                  GPIO_Pin_7
#define SPIx_MOSI_GPIO_PORT            GPIOA
#define SPIx_MOSI_GPIO_CLK             RCC_AHB1Periph_GPIOA
#define SPIx_MOSI_SOURCE               GPIO_PinSource7
#define SPIx_MOSI_AF                   GPIO_AF_SPI1

#define GPIO_SPI_READY_PORT			   0 //GPIOA
#define GPIO_SPI_READY_PIN			       4 //pin 4

#define GPIO_SPI_BUSY_PORT			   		0 //GPIOA
#define GPIO_SPI_BUSY_PIN			        10 //pin 10



#define SPI_DATA_RX_BUFFER_SIZE 	1024*4
#define SPI_DATA_TX_BUFFER_SIZE 	1024*4

#define WRITE_CMD 1
#define READ_CMD  2


void STM32_SPI_Open(void);
UINT32 STM32_SPI_ReadBytes(UINT8 *data, UINT32 index, UINT32 length);
UINT32 STM32_SPI_WriteBytes(UINT8 *data, UINT32 index, UINT32 length);
UINT32 STM32_SPI_WriteBytesDMA(UINT8 *data, UINT32 index, UINT32 length);
UINT32 STM32_SPI_ReadyPinState(void);
UINT32 STM32_SPI_BusyPinState(void);
void  STM32_SPI_PutC(UINT8 b);
UINT8 STM32_SPI_GetC(void);


#define NUM_BLOCK 10000






