#include "..\\Driver\\stm32f2xx_usart.h"
#include "..\\Driver\\stm32f2xx_rcc.h"
#include "..\\Driver\\misc.h"
#include "..\\GPIO\\GPIO.h"
//#include "..\\SourceFile\\Defines.h"
//#include "..\\Driver\\stm32f2xx_usart.h"
//#include "..\\GPIO\\GPIO.h"
/* Define to prevent recursive inclusion -------------------------------------*/


/**
*****************************************************************************
* File: ALFAT_UART.h												   
* Copyright 2012 GHI Electronics, LLC 								   
* These are basic configurations to to access ALFAT SoC Processor through USART interface.
* For demonstration purposes only. not to be used in production.
*
* THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
* ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
* CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.								   *
************************************************************************
**/




#define UART_DATA_RX_BUFFER_SIZE 	1024*4
#define UART_DATA_TX_BUFFER_SIZE 	1024*4

void STM32_USART_Open(void);
UINT8 STM32_USART_GetC(void);
void STM32_USART_PutC(UINT8 b);
void Config_UART(INT32 Baudrate);
void NVIC_Config(void);
UINT32 STM32_USART_BusyPinState(void);
UINT32 STM32_USART_ReadyPinState(void);
UINT32 STM32_USART_WriteBytes(UINT8 *data, UINT32 index, UINT32 length);
UINT32 STM32_USART_WriteBytesDMA(UINT8 *data, UINT32 index, UINT32 length);
UINT32 STM32_USART_ReadBytes(UINT8 *data, UINT32 index, UINT32 length);


#define GPIO_USART_READY_PORT			   0 //GPIOA
#define GPIO_USART_READY_PIN			   4 //pin 15

#define GPIO_USART_BUSY_PORT			   0 //GPIOA
#define GPIO_USART_BUSY_PIN			       6 //pin 6




#define NUM_BLOCK 10000
#define BLOCK_SIZE 4*1024
#define USER_TIME_OUT 1000
#define USER_TIME_DELAY 1000



